{From: sbausson@ensem.u-nancy.fr (Stephane BAUSSON)
Newsgroups: sci.electronics
Subject: TELECARDS INFORMATIONS
Date: 25 Nov 1993 21:11:08 GMT
Organization: Ensem, Nancy, France
Distribution: world
NNTP-Posting-Host: fourier.ensem.u-nancy.fr}

Program telecard_reader;
{ Originally written by Stephane Bausson }
{ Modified by Tomi Engdahl 4.12.1993 }
uses crt,dos;

type string8=string[8];

var reg:registers;
    i,j:integer;
    bb:array[1..32] of string8;
    bh:array[1..32] of byte;
    l:array[1..256] of boolean;
    car:char;

{-----------------------------------------------------------------------------}

procedure writeln_binaire(w:byte);

  begin if (w and $80)=$80 then write('1') else write('0');
        if (w and $40)=$40 then write('1') else write('0');
        if (w and $20)=$20 then write('1') else write('0');
        if (w and $10)=$10 then write('1') else write('0');
        if (w and $08)=$08 then write('1') else write('0');
        if (w and $04)=$04 then write('1') else write('0');
        if (w and $02)=$02 then write('1') else write('0');
        if (w and $01)=$01 then write('1') else write('0');
        writeln;
  end;

{-----------------------------------------------------------------------------}

procedure send(b:byte);

  begin {reg.AH:=$00;
        reg.AL:=b;
        reg.DX:=0;
        intr($17,reg);}
        Port[MemW[$0040:$0008]]:=b;
        Delay(10);
  end;

{-----------------------------------------------------------------------------}

function get:byte;

  begin {reg.AH:=$02;
        reg.DX:=0;
        intr($17,reg);
        get:=reg.AH;}
        get:=Port[MemW[$0040:$0008]+1];
  end;

{-----------------------------------------------------------------------------}

function unites:byte;

  var u,idx:integer;

  begin u:=0;
        idx:=97;
        while (l[idx] and (idx<257)) do
        begin inc(u);
              inc(idx);
        end;
        unites:=u;
  end;

{-----------------------------------------------------------------------------}

procedure type_carte;

  begin case bh[2] of
         $03: begin write('Telecard - France - ');
                    case bh[12] of
                     $13: write('120 Units - ',unites-130,' Units left');
                     $06: write('50 Units - ',unites-60,' Units left');
                     $15: write('40 Units - ',unites-40,' Units left');
                    end;
              end;
         $83:begin case bh[12] of
                     $30: write('Telecard - Norway - ');
                     $3C: write('Telecard - Ireland - ');
                     $55: write('Telecard - Czech Republic - ');
                     $65: write('Telecard - Finland - ');
                   end;
                   if bh[12] in [$30,$3C,$55,$65] then
                   begin case ((bh[3] and $0F)*$100+bh[4]) of
                          $012: write ('10 Units - ',unites-12,' Units left');
                          $024: write ('22 Units - ',unites-24,' Units left');
                          $027: write ('25 Units - ',unites-27,' Units left');
                          $032: write ('30 Units - ',unites-32,' Units left');
                          $052: write ('50 Units - ',unites-52,' Units left');
                          $070: write ('70 Units - ',unites-70,' Units left');
                          $082: write ('80 Units - ',unites-82,' Units left');
                          $102: write ('100 Units - ',unites-102,' Units left');
                          $152: write ('150 Units -  ',unites-152,' Units left');
                         end;
                    end;
                    write(' - N# ',bh[5]*$100+bh[6]);
              end;
        end;
  end;

{-----------------------------------------------------------------------------}

procedure attente;

  begin send($00);
        {write('Entrer une carte et presser une touche ...');}
        Write('Insert card and press control key (Q=quit W=write R=read)...');
        repeat until keypressed;
  end;

{-----------------------------------------------------------------------------}

function value(s:string8):byte;

  var b:byte;

  begin b:=0;
        if s[8]='1' then b:=b+$01;
        if s[7]='1' then b:=b+$02;
        if s[6]='1' then b:=b+$04;
        if s[5]='1' then b:=b+$08;
        if s[4]='1' then b:=b+$10;
        if s[3]='1' then b:=b+$20;
        if s[2]='1' then b:=b+$40;
        if s[1]='1' then b:=b+$80;
        value:=b;
  end;

{-----------------------------------------------------------------------------}

procedure write_hexa(s:string);

  var i:integer;

  begin if s='0000' then write('0') else
        if s='0001' then write('1') else
        if s='0010' then write('2') else
        if s='0011' then write('3') else
        if s='0100' then write('4') else
        if s='0101' then write('5') else
        if s='0110' then write('6') else
        if s='0111' then write('7') else
        if s='1000' then write('8') else
        if s='1001' then write('9') else
        if s='1010' then write('A') else
        if s='1011' then write('B') else
        if s='1100' then write('C') else
        if s='1101' then write('D') else
        if s='1110' then write('E') else
        if s='1111' then write('F');
  end;

{-----------------------------------------------------------------------------}

procedure lecture;

  var i,j,k:integer;

  begin send($FA);
        send($F8);
        k:=1;
        for i:=1 to 32 do
        begin bb[i]:='';
              for j:=1 to 8 do
              begin send($F9);
                    l[k]:=not((get and $80)=$80);
                    if l[k] then insert('1',bb[i],j) else insert('0',bb[i],j);
                    send($FB);
                    inc(k);
              end;
        end;

        for i:=1 to 32 do bh[i]:=value(bb[i]);

        writeln('Memory dump:');
        for i:=1 to 80 do write('-');
        for i:=1 to 6 do
        begin for j:=1 to 6 do
              begin if j+6*(i-1) <= 32 then write(bb[j+6*(i-1)]:9);
              end;
              gotoxy(60,wherey);
              for j:=1 to 6 do
              if j+6*(i-1) <= 32 then
              begin write_hexa(copy(bb[j+6*(i-1)],1,4));
                    write_hexa(copy(bb[j+6*(i-1)],5,4));
                    write(' ');
              end;
              writeln;
        end;
        for i:=1 to 80 do write('-');
        type_carte;
        writeln;
        writeln;
  end;

{-----------------------------------------------------------------------------}

procedure ecriture;

  var i,n:integer;
      car:char;

  begin {write('Quel bit voulez vous mettre a "1" : ');}
        write('Give the number of the bit to set to "1" : ');
        readln(n);

        attente;
        car:=readkey;

        send($FA);
        send($F8);
        for i:=1 to n do
        begin send($F9);
              if i=n then
              begin send($FD);
                    delay(20);
                    send($FF);
                    delay(20);
              end;
              send($FB);
        end;
        lecture;
  end;

{=============================================================================}

begin clrscr;
      {writeln('Entrer une carte et tappez une touche ......');}
      writeln('Telecard reader program by Stephane Bausson');
      Writeln('Modified by Tomi Engdahl');
      writeln;
      repeat attente;
             car:=upcase(readkey);
             Writeln(car);
             case car of
              'W':ecriture;
              'Q':;
              else begin lecture
                   end;
             end;
      until car='Q';
end.
